SystemOrganization addCategory: #'Xpf-CodeMarker'!
SystemOrganization addCategory: #'Xpf-Seaside-Components'!
SystemOrganization addCategory: #'Xpf-CodeMarker-Commands'!
SystemOrganization addCategory: #'Xpf-Tests-Models'!
SystemOrganization addCategory: #'Xpf-Models'!
SystemOrganization addCategory: #'Xpf-Rest'!
SystemOrganization addCategory: #'Xpf-Seaside-ComponentsTest'!
SystemOrganization addCategory: #Xpf!

!String methodsFor: '*xpf-codemarker' stamp: 'topa 2/12/2009 21:34'!
findAllStrings: aString
	"Returns a collection with all starting indices of the given string in me."
	
	|indices currentStartIndex|
	indices := Bag new.
	currentStartIndex := 1.
	
	[currentStartIndex := (self findString: aString startingAt: currentStartIndex) + 1.
		currentStartIndex > 1 
	] whileTrue: [indices add: currentStartIndex - 1].

	^indices! !

!OBCmdMultiView methodsFor: '*xpf-codemarker' stamp: 'mt 2/13/2009 14:27'!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint Xpf).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*xpf-codemarker' stamp: 'cs 1/15/2009 17:24'!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:47'!
toggleXpf

	self styler: XpfTextStyler new.
	self setTextInDefinitionPanel: target source.! !

HttpService subclass: #XpfHttpService
	instanceVariableNames: 'handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Rest'!

XpfHttpService class
	instanceVariableNames: 'service port'!

XpfHttpService class
	instanceVariableNames: 'service port'!

!XpfHttpService class methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 13:55'!
createService
	^ XpfHttpService on: port.! !

!XpfHttpService class methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 13:55'!
run
	self stop.
	
	port := 8080.
	service := self createService.
	service
		installHandler: XpfMetaHandler on: '/meta';
		installHandler: XpfDefaultHandler on: '/';
		start.! !

!XpfHttpService class methodsFor: 'as yet unclassified' stamp: 'mt 1/30/2009 13:28'!
stop
	service ifNotNil:
		[service unregister.
		service := nil].
	port := nil.! !

!XpfHttpService methodsFor: 'as yet unclassified' stamp: 'mt 2/2/2009 10:12'!
initialize
	super initialize.
	handlers := OrderedCollection new	"needed for priorities"! !

!XpfHttpService methodsFor: 'as yet unclassified' stamp: 'mt 2/2/2009 10:12'!
installHandler: aRequestHandlerClass on: aPathString 
	handlers add: aPathString -> aRequestHandlerClass! !

!XpfHttpService methodsFor: 'as yet unclassified' stamp: 'mt 2/2/2009 10:27'!
processHttpRequest: request
	
	| activeHandler path |
	activeHandler := (handlers detect: [:ass| 
		path := ass key.
		request url includesSubString: path
		]) value.
	^(activeHandler new) process: request! !

TestCase subclass: #XpfTestCase
	instanceVariableNames: 'originalDatabase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Models'!

XpfTestCase subclass: #XpfEntityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Models'!

!XpfEntityTest methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:06'!
testRegistration
	| count entity |
	count := XpfEntity entities size.	
	entity := XpfEntity new. 

	entity register.	
	self should: XpfEntity entities size = (count + 1).
	
	entity unregister.
	self should: XpfEntity entities size = count.! !

XpfTestCase subclass: #XpfTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Models'!

!XpfTaskTest methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:49'!
testHasTasks
	
	| userStory task storyCount |
	storyCount := XpfUserStory entities size.
	task := XpfTask newAndRegister: [ :t | t ].
	self should: task taskUserStories size = 0.
	userStory := task addUserStory: (XpfUserStory newAndRegister: [ :s | s]).
	self 
		should: task taskUserStories size = 1;
		should: XpfUserStory entities size = (storyCount + 1);
		should: 	(userStory storyTasks includes: task).
	task removeUserStory: userStory.
	self 
		should: task taskUserStories size = 0;
		should: XpfUserStory entities size = (storyCount + 1).
	task unregister.
	userStory unregister.! !

!XpfTaskTest methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:45'!
testHasUserStory! !

!XpfTaskTest methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:07'!
testNewAndDelete
	| task oldCount |
	
	oldCount := XpfTask entities size.
	
	task := XpfTask newAndRegister: [ :newTask | 
		newTask
			taskName: 'test task';
			taskDescription: 'this is a test task' ;
			yourself].
		
	self 
		should: XpfTask entities size = (oldCount + 1);
		should: (XpfTask entities anySatisfy: [ :each | each taskName = 'test task' ]).
	
	task unregister.
	
	self should: XpfTask entities size = oldCount.! !

!XpfTestCase class methodsFor: 'testing' stamp: 'topa 2/13/2009 14:04'!
isAbstract
 	^self name = #XpfTestCase! !

!XpfTestCase methodsFor: 'testing' stamp: 'topa 2/12/2009 10:53'!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self
		should: (aTargetObject perform: aSelector) == anObject
		! !

!XpfTestCase methodsFor: 'testing' stamp: 'topa 2/12/2009 14:03'!
denyAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject
	 that dont behave like plain accessors.
	"
	self
		shouldnt: (aTargetObject perform: aSelector) == anObject
		! !

XpfTestCase subclass: #XpfUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Models'!

!XpfUserStoryTest methodsFor: 'tests' stamp: 'topa 2/13/2009 14:08'!
testAttributes
	| us |
	us := XpfUserStory new.
	self
		checkAccessor: #storyName on: us with: 'US + Tasks verwalten';
		checkAccessor: #storyDescription on: us with: 'Dinge tun und Sachen machen';
		checkAccessor: #storyPriority on: us with: 5;
		checkAccessor: #storyEstimate on: us  with: 10;
		checkAccessor: #storyActual on: us  with: 12;
		checkAccessor: #storyTasks on: us  with: (Set with: XpfTask new with: XpfTask new). 
		
! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'topa 2/13/2009 14:50'!
testHasTasks
	
	| userStory taskCount task|
	taskCount := XpfTask entities size.
	userStory := XpfUserStory newAndRegister: [ :newUserStory | newUserStory ].
	self should: userStory storyTasks size = 0.
	task := userStory addTask: (XpfTask newAndRegister: [ :newTask | newTask ]).
	self 
		should: userStory storyTasks size = 1;
		should: XpfTask entities size = (taskCount + 1);
		should: 	(task taskUserStories includes: userStory).
	userStory removeTask: task.
	self 
		should: userStory storyTasks size = 0;
		should: XpfTask entities size = (taskCount + 1).
	userStory unregister.
	task unregister.! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'topa 2/13/2009 14:07'!
testNewAndDelete
	| userStory oldCount |
	
	oldCount := XpfUserStory entities size.
	
	userStory := XpfUserStory newAndRegister: [ :newUserStory | 
		newUserStory
			storyName: 'test story';
			storyDescription: 'this is a test story';
			storyPriority: 3;
			storyEstimate: 10 ].
		
	self 
		should: XpfUserStory entities size = (oldCount + 1);
		should: (XpfUserStory entities anySatisfy: [ :each | each storyName = 'test story' ]).
	
	userStory unregister.
	
	self should: XpfUserStory entities size = oldCount.
	! !

XpfTestCase subclass: #XpfUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Models'!

!XpfUserTest methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:05'!
testAttributes
	| user |
	user := XpfUser new.
	self
		checkAccessor: #userLogin on: user with: 'marcel.taeumel';
		checkAccessor: #userFirstName on: user with: 'Marcel';
		checkAccessor: #userLastName on: user with: 'Taeumel';
		checkAccessor: #userEMail on: user with: 'marcel.taeumel@student.hpi.uni-potsdam.de'.! !

!XpfUserTest methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:06'!
testNewAndDelete
	| user oldCount |
	
	self shouldnt: (XpfUser entities anySatisfy: [ :each | each userLogin = 'stefanc.richter' ]).
	
	oldCount := XpfUser entities size.
	
	user := XpfUser newAndRegister: [ :newUser | 
		newUser
			userLogin: 'stefanc.richter';
			userFirstName: 'Stefan';
			userLastName: 'Richter';
			userEMail: 'stefanc.richter@student.hpi.uni-potsdam.de'].
		
	self 
		should: XpfUser entities size = (oldCount + 1);
		should: (XpfUser entities anySatisfy: [ :each | each userLogin = 'stefanc.richter' ]).
	
	user unregister.
	
	self should: XpfUser entities size = oldCount.! !

SCComponentTestCase subclass: #XpfComponentTestCase
	instanceVariableNames: 'originalDatabase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Seaside-ComponentsTest'!

!XpfComponentTestCase class methodsFor: 'testing' stamp: 'topa 2/13/2009 14:04'!
isAbstract
 	^self name = #XpfComponentTestCase! !

XpfComponentTestCase subclass: #XpfTaskComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Seaside-ComponentsTest'!

!XpfTaskComponentTest methodsFor: 'running' stamp: 'topa 2/13/2009 13:53'!
setUp
	super setUp.
	self 
		newApplicationWithRootClass: XpfTaskComponent;
		establishSession.! !

!XpfTaskComponentTest methodsFor: 'tests' stamp: 'topa 1/23/2009 15:50'!
testNewTask
	self
		followAnchor: (self lastResponse anchorWithLabel: 'Add Task');
		assert: (self lastResponse forms size = 1).
	self testTaskForm: self lastResponse forms first.
		! !

!XpfTaskComponentTest methodsFor: 'testing' stamp: 'topa 2/10/2009 15:30'!
testTaskForm: aForm
	self 
		assert: aForm textInputs size = 2 description: 'A task should have 2 data inputs';
		assert: aForm buttons size = 3 description: 'A task should be addable, yet the addition canceable';
		assert: aForm buttons second value = 'Save';
		assert: aForm buttons third value = 'Cancel'.! !

XpfComponentTestCase subclass: #XpfUserStoryComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Seaside-ComponentsTest'!

!XpfUserStoryComponentTest methodsFor: 'running' stamp: 'topa 2/13/2009 13:53'!
setUp
	super setUp.
	self 
		newApplicationWithRootClass: XpfUserStoryComponent;
		establishSession.! !

!XpfUserStoryComponentTest methodsFor: 'tests' stamp: 'topa 1/23/2009 16:17'!
testNewUserStory
	self
		followAnchor: (self lastResponse anchorWithLabel: 'Add User Story');
		assert: (self lastResponse forms size = 1).
	self testUserStoryForm: self lastResponse forms first.
		! !

!XpfUserStoryComponentTest methodsFor: 'testing' stamp: 'topa 2/12/2009 14:50'!
testUserStoryForm: aForm
	self 
		assert: aForm textInputs size = 5 description: 'A task should have 5 data inputs';
		assert: aForm buttons size = 4 description: 'A user story should be addable, yet the addition canceable';
		assert: aForm buttons first value = 'Default'; "this seems to be Magritte specific"
		assert: aForm buttons second value = 'Add';
		assert: aForm buttons third value = 'Save';
		assert: aForm buttons fourth value = 'Cancel'.! !

OBTextMorphEditorWithShout subclass: #XpfEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker'!

!XpfEditor class methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
initializeCmdKeyShortcuts
	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($q asInteger + 1) put: #markAsGood:;
		at: ($r asInteger + 1) put: #markAsBad:;
		at: ($t asInteger + 1) put: #markAsUnclear:;
		at: ($w asInteger + 1) put: #removeMarkup:.
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:43'!
markAsBad: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color red.
	self userHasEdited.
	^ true

	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 1/23/2009 14:44'!
markAsGood: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color green.
	self userHasEdited.
	^ true
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:17'!
markAsUnclear: aCharacterStream
	paragraph setBackgroundForSelectionWith: Color lightGray.
	self userHasEdited.
	^ true
	
! !

!XpfEditor methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:36'!
removeMarkup: aCharacterStream
	paragraph removeBackgroundForSelection.
	self userHasEdited.
	^ true

	
! !

!Text methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 17:42'!
removeAttributeOfKind: attClass from: start to: stop 
	"Removes an attribute kind over the interval start to stop."
	runs :=  runs copyReplaceFrom: start to: stop
			with: ((runs copyFrom: start to: stop)
				mapValues:
				[:attributes | attributes reject: [:each | each isKindOf: attClass]])! !

WAComponent subclass: #XpfRootComponent
	instanceVariableNames: 'userStoryAdmin taskAdmin navigation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Seaside-Components'!

!XpfRootComponent class methodsFor: 'testing' stamp: 'mig 1/23/2009 13:58'!
canBeRoot
	^ true! !

!XpfRootComponent class methodsFor: 'initialization' stamp: 'topa 2/13/2009 14:03'!
initialize
    (self registerAsApplication: 'xpf')
        addLibrary: SULibrary.! !

!XpfRootComponent methodsFor: 'rendering' stamp: 'topa 1/23/2009 15:10'!
children
	^ Array with: self navigation! !

!XpfRootComponent methodsFor: 'initialize-release' stamp: 'topa 2/13/2009 13:55'!
initialize
	super initialize.
	self
		userStoryAdmin: XpfUserStoryComponent new;
		taskAdmin: XpfTaskComponent new;
		initializeNavigation! !

!XpfRootComponent methodsFor: 'initialize-release' stamp: 'topa 1/23/2009 15:12'!
initializeNavigation
	self navigation: WASimpleNavigation new.
	(self navigation)
		add: self userStoryAdmin label: 'User Stories';
		add: self taskAdmin label: 'Tasks';
		select: self navigation options first! !

!XpfRootComponent methodsFor: 'accessing' stamp: 'topa 1/23/2009 15:10'!
navigation
	^ navigation! !

!XpfRootComponent methodsFor: 'accessing' stamp: 'topa 1/23/2009 15:12'!
navigation: anObject 
	navigation := anObject! !

!XpfRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:16'!
taskAdmin
	^ taskAdmin! !

!XpfRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:16'!
taskAdmin: anObject
	taskAdmin := anObject! !

!XpfRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:04'!
userStoryAdmin
	^ userStoryAdmin! !

!XpfRootComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:04'!
userStoryAdmin: anObject
	userStoryAdmin := anObject! !

WAComponent subclass: #XpfTaskComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Seaside-Components'!

!XpfTaskComponent class methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 14:06'!
canBeRoot
	^ false! !

!XpfTaskComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:14'!
children
	^ Array with: report! !

!XpfTaskComponent methodsFor: 'actions' stamp: 'topa 2/13/2009 14:04'!
createNewTask

	XpfTask newAndRegister: [:newTask |
		self call: newTask asComponent addValidatedForm ].
	self refreshReport.! !

!XpfTaskComponent methodsFor: 'actions' stamp: 'topa 2/9/2009 22:22'!
deleteTask: aTask

	(self confirm: ('Do you really want to delete the task named "{1}"?' format: {aTask taskName}))
		ifTrue: [aTask unregister. self refreshReport.].! !

!XpfTaskComponent methodsFor: 'actions' stamp: 'mig 1/23/2009 14:13'!
editTask: aTask
	(self call: (aTask description asComponentOn: aTask) addValidatedForm)
		ifNotNil: [self refreshReport].! !

!XpfTaskComponent methodsFor: 'initialize-release' stamp: 'mig 1/23/2009 14:07'!
initialize
	super initialize.
	self initializeReport.! !

!XpfTaskComponent methodsFor: 'initialize-release' stamp: 'topa 2/13/2009 14:13'!
initializeReport
	self report: (MAReport
 		rows: XpfTask entities
 		description: XpfTask new descriptionReport).
		
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editTask: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteTask: text: 'delete';
			yourself).! !

!XpfTaskComponent methodsFor: 'updating' stamp: 'topa 2/13/2009 14:04'!
refreshReport
	self report rows: XpfTask all.! !

!XpfTaskComponent methodsFor: 'rendering' stamp: 'mig 1/23/2009 14:41'!
renderContentOn: html
	html div with: [
		html div 
			with: self report.
		html anchor 
			callback: [self createNewTask]; 
			with: 'Add Task'. ]! !

!XpfTaskComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:06'!
report
	^ report! !

!XpfTaskComponent methodsFor: 'accessing' stamp: 'mig 1/23/2009 14:06'!
report: anObject
	report := anObject! !

WAComponent subclass: #XpfUserStoryComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Seaside-Components'!

!XpfUserStoryComponent class methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 13:58'!
canBeRoot
	^false! !

!XpfUserStoryComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:44'!
children
	^Array with: self report.! !

!XpfUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:09'!
createNewUserStory

	XpfUserStory newAndRegister: [:newUserStory |
		self call: newUserStory asComponent addValidatedForm ].
	self refreshReport.
! !

!XpfUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'topa 2/9/2009 22:23'!
deleteUserStory: aUserStory

	(self confirm: ('Do you really want to delete the user story named "{1}"?' format: {aUserStory storyName})) ifTrue: [aUserStory unregister. self refreshReport ]! !

!XpfUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'mig 1/23/2009 12:32'!
editUserStory: aUserStory
	(self call: (aUserStory description asComponentOn: aUserStory) addValidatedForm)
		ifNotNil: [self refreshReport].! !

!XpfUserStoryComponent methodsFor: 'initialization' stamp: 'SR 1/22/2009 14:33'!
initialize
	super initialize.
	self initializeReport.! !

!XpfUserStoryComponent methodsFor: 'initialization' stamp: 'topa 2/13/2009 14:13'!
initializeReport
	self report: (MAReport
 		rows: XpfUserStory entities
 		description: XpfUserStory new descriptionReport).
		
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editUserStory: text: 'edit';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteUserStory: text: 'delete';
			yourself).! !

!XpfUserStoryComponent methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:10'!
refreshReport
	self report rows: (XpfUserStory all).! !

!XpfUserStoryComponent methodsFor: 'rendering' stamp: 'mig 1/23/2009 14:41'!
renderContentOn: html
	html div with: [
		html div 
			with: self report.
		html anchor 
			callback: [self createNewUserStory]; 
			with: 'Add User Story'. ]! !

!XpfUserStoryComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45'!
report
	^ report! !

!XpfUserStoryComponent methodsFor: 'accessing' stamp: 'SR 1/22/2009 14:45'!
report: anObject
	report := anObject! !

Object subclass: #XpfEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

XpfEntity class
	instanceVariableNames: 'entities'!

!XpfEntity commentStamp: 'mt 2/12/2009 12:20' prior: 0!
I am the abstract superclass of all entities in the system. These entities could be user stories, tasks, developers, themes, ...!

XpfEntity class
	instanceVariableNames: 'entities'!

!XpfEntity class methodsFor: 'accessing' stamp: 'topa 2/12/2009 18:42'!
entities
	^ entities! !

!XpfEntity class methodsFor: 'accessing' stamp: 'topa 2/12/2009 18:42'!
entities: aCollection
	entities := aCollection.! !

!XpfEntity class methodsFor: 'initialization' stamp: 'topa 2/12/2009 18:37'!
initialize
	super initialize.
	self entities: Set new.! !

!XpfEntity class methodsFor: 'accessing' stamp: 'test 2/10/2009 15:25'!
newAndRegister: aBlockContext
	| entity |
	entity := aBlockContext value: self new.
	entity ifNotNil: [entity register].
	^ entity! !

!XpfEntity methodsFor: 'registry' stamp: 'topa 2/12/2009 18:43'!
register
	"register with the database"
	self class entities add: self.! !

!XpfEntity methodsFor: 'registry' stamp: 'topa 2/12/2009 18:44'!
unregister
	"unregister from database"
	self class entities remove: self.! !

XpfEntity subclass: #XpfTask
	instanceVariableNames: 'taskName taskDescription taskUserStories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfTask commentStamp: 'mt 2/12/2009 12:22' prior: 0!
I am a task in tems of Extreme Programming.!

!XpfTask class methodsFor: 'description' stamp: 'mig 1/23/2009 13:54'!
descriptionDescription
	^MAMemoDescription new
		selectorAccessor: #taskDescription;
		label: 'Description';
		priority: 20;
		yourself! !

!XpfTask class methodsFor: 'description' stamp: 'mig 1/23/2009 13:54'!
descriptionName
	^MAStringDescription new
		selectorAccessor: #taskName;
		label: 'Name';
		priority: 10;
		default: 'New Task';
		yourself! !

!XpfTask class methodsFor: 'as yet unclassified' stamp: 'topa 2/12/2009 14:43'!
new
	^super new! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:54'!
addUserStory: anXpfUserStory
	(anXpfUserStory hasTask: self)
		ifFalse: [anXpfUserStory addTask: self].
	^ self taskUserStories add: anXpfUserStory
	! !

!XpfTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:49'!
descriptionReport
	^super description 
		select: [:each | #(taskName taskDescription) includes: each accessor selector]! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:58'!
hasUserStory: anXpfUserStory
	^ self taskUserStories includes: anXpfUserStory! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:34'!
initialize
	super initialize.
	self taskUserStories: Set new.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:56'!
removeUserStory: anXpfUserStory
	(anXpfUserStory hasTask: self)
		ifTrue: [anXpfUserStory removeTask: self].
	^ self taskUserStories remove: anXpfUserStory! !

!XpfTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!
taskDescription
	^ taskDescription! !

!XpfTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!
taskDescription: anObject
	taskDescription := anObject! !

!XpfTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!
taskName
	^ taskName! !

!XpfTask methodsFor: 'accessing' stamp: 'mig 1/23/2009 13:48'!
taskName: anObject
	taskName := anObject! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:33'!
taskUserStories
	^taskUserStories! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:33'!
taskUserStories: aCollection
	taskUserStories := aCollection! !

XpfEntity subclass: #XpfUser
	instanceVariableNames: 'userLogin userFirstName userLastName userEMail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfUser commentStamp: 'mt 2/12/2009 12:24' prior: 0!
I am a system or application user. This could be an administrator, webmaster, developer or something like that.!

!XpfUser class methodsFor: 'description' stamp: 'mt 2/10/2009 16:07'!
descriptionEMail
	^MAStringDescription new
		selectorAccessor: #userEMail;
		label: 'E-Mail';
		priority: 30;
		default: '';
		yourself! !

!XpfUser class methodsFor: 'description' stamp: 'mt 2/10/2009 16:06'!
descriptionFirstName
	^MAStringDescription new
		selectorAccessor: #userFirstName;
		label: 'First name';
		priority: 20;
		default: '';
		yourself! !

!XpfUser class methodsFor: 'description' stamp: 'mt 2/10/2009 16:07'!
descriptionLastName
	^MAStringDescription new
		selectorAccessor: #userLastName;
		label: 'Last name';
		priority: 20;
		default: '';
		yourself! !

!XpfUser class methodsFor: 'description' stamp: 'mt 2/10/2009 16:05'!
descriptionLogin
	^MAStringDescription new
		selectorAccessor: #userLogin;
		label: 'Login';
		priority: 10;
		default: '';
		yourself! !

!XpfUser methodsFor: 'description' stamp: 'mt 2/10/2009 16:09'!
descriptionReport
	^super description 
		select: [:each | #(userLogin userFirstName userLastName userEMail) includes: each accessor selector]! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userEMail
	^ userEMail! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userEMail: anObject
	userEMail := anObject! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userFirstName
	^ userFirstName! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userFirstName: anObject
	userFirstName := anObject! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userLastName
	^ userLastName! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userLastName: anObject
	userLastName := anObject! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userLogin
	^ userLogin! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 2/10/2009 15:44'!
userLogin: anObject
	userLogin := anObject! !

XpfEntity subclass: #XpfUserStory
	instanceVariableNames: 'storyName storyDescription storyPriority storyEstimate storyActual storyTasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Models'!

!XpfUserStory commentStamp: 'topa 2/12/2009 14:06' prior: 0!
I am a user story in terms of Extreme Programming!

!XpfUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!
descriptionActual
	^MANumberDescription new
		selectorAccessor: #storyActual;
		label: 'Actual';
		priority: 40;
		default: 0;
		yourself! !

!XpfUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!
descriptionDescription
	^MAMemoDescription new
		selectorAccessor: #storyDescription;
		label: 'Description';
		priority: 20;
		yourself! !

!XpfUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!
descriptionEstimate
	^MANumberDescription new
		selectorAccessor: #storyEstimate;
		label: 'Estimate';
		priority: 40;
		default: 0;
		yourself! !

!XpfUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:08'!
descriptionName
	^MAStringDescription new
		selectorAccessor: #storyName;
		label: 'Name';
		priority: 10;
		default: 'New User Story';
		yourself! !

!XpfUserStory class methodsFor: 'description' stamp: 'SR 1/22/2009 15:07'!
descriptionPriority
	^MANumberDescription new
		selectorAccessor: #storyPriority;
		label: 'Priority';
		priority: 30;
		default: 3;
		yourself! !

!XpfUserStory class methodsFor: 'description' stamp: 'topa 2/12/2009 14:31'!
descriptionTasks
	^MAToManyRelationDescription new
		selectorAccessor: #storyTasks;
		label: 'Tasks';
		classes: {XPFTask};
		priority: 50;
		yourself! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:57'!
addTask: anXpfTask
	(anXpfTask hasUserStory: self)
		ifFalse: [anXpfTask addUserStory: self].
	^ self storyTasks add: anXpfTask
! !

!XpfUserStory methodsFor: 'description' stamp: 'cs 1/26/2009 14:44'!
descriptionReport
	^super description 
		select: [:each | #(storyName storyEstimate storyPriority storyTasks) includes: each accessor selector]! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:55'!
hasTask: anXpfTask
	^ self storyTasks includes: anXpfTask! !

!XpfUserStory methodsFor: 'initialize-release' stamp: 'topa 2/12/2009 18:47'!
initialize
	super initialize.
	self storyTasks: Set new.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 2/13/2009 14:58'!
removeTask: anXpfTask
	(anXpfTask hasUserStory: self)
		ifTrue: [anXpfTask removeUserStory: self].
	^ self storyTasks remove: anXpfTask! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 2/5/2009 17:48'!
storyActual
	^ storyActual! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04'!
storyActual: anObject
	storyActual := anObject! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyDescription
	^ storyDescription! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyDescription: anObject
	storyDescription := anObject! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyEstimate
	^ storyEstimate! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyEstimate: anObject
	storyEstimate := anObject! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyName
	^ storyName! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyName: anObject
	storyName := anObject! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyPriority
	^ storyPriority! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05'!
storyPriority: anObject
	storyPriority := anObject! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 2/12/2009 18:46'!
storyTasks
	^ storyTasks! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 2/12/2009 14:57'!
storyTasks: aCollection
	storyTasks :=  aCollection! !

Object subclass: #XpfHttpRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Rest'!

XpfHttpRequestHandler subclass: #XpfDefaultHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Rest'!

!XpfDefaultHandler methodsFor: 'request processing' stamp: 'mt 2/2/2009 09:56'!
process: anHttpRequest
	^HttpResponse fromString: 'Default Handler.'! !

!XpfHttpRequestHandler methodsFor: 'request processing' stamp: 'mt 2/2/2009 09:53'!
process: anHttpRequest
	self subclassResponsibility.! !

XpfHttpRequestHandler subclass: #XpfMetaHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Rest'!

!XpfMetaHandler methodsFor: 'request processing' stamp: 'mt 2/2/2009 10:23'!
process: anHttpRequest
	"Takes first element in path as classname and sends message from second path element to that class."

	|pc class selector result|
	pc := (URI fromString: anHttpRequest url) pathComponents.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [
			result := c perform: selector]].

	^ HttpResponse fromString: result printString.! !

Object subclass: #XpfLogService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Rest'!

!XpfLogService class methodsFor: 'service' stamp: 'cs 2/7/2009 14:20'!
log: aCollection
	Transcript show: aCollection first asString; cr.! !

SHTextStylerST80 subclass: #XpfTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker'!

!XpfTextStyler methodsFor: 'private' stamp: 'mt 1/26/2009 14:55'!
privateFormat: aText
	^super privateFormat: aText.! !

!XpfTextStyler methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
privateStyle: aText
	"First, backup current style information about background color in text runs. Then let Shout work. Then restore background color information for text runs."

	| backupRuns |
	backupRuns := aText runs.

	super privateStyle: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfTextBackgroundColor] ifNone: [nil].
		a ifNotNil: [aText addAttribute: a from: start to: stop].
	]! !

!XpfTextStyler methodsFor: 'as yet unclassified' stamp: 'topa 2/13/2009 14:09'!
unstyledTextFrom: aText

	| backupRuns result |
	backupRuns := aText runs.

	result := super unstyledTextFrom: aText.
	
	backupRuns withStartStopAndValueDo: [:start :stop :attrs | |a|
		a := attrs detect: [:attr | attr isKindOf: XpfTextBackgroundColor] ifNone: [nil].
		a ifNotNil: [result addAttribute: a from: start to: stop].
	].

	^result.! !

!OBCodeBrowser methodsFor: '*xpf-codemarker-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsBad
	^ XpfMarkBadCommand! !

!OBCodeBrowser methodsFor: '*xpf-codemarker-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsGood
	^ XpfMarkGoodCommand! !

!OBCodeBrowser methodsFor: '*xpf-codemarker-commands' stamp: 'topa 2/13/2009 13:41'!
cmdMarkAsUnclear
	^ XpfMarkUnclearCommand! !

!OBCodeBrowser methodsFor: '*xpf-codemarker-commands' stamp: 'topa 2/13/2009 13:43'!
cmdRemoveMarkup
	^ XpfRemoveMarkupCommand! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:08'!
markBadIcon
	^ Icons
			at: #'markBad'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markBadIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:06'!
markBadIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAACxSURBVDjL7dItC8JQAIXh491H
WbDvD1pEDIIKm1zDxqKi0WIULAZFYc1msF3ErEZlMC9Mhxx/gTAR28KpDxx4QRK/DCXwAbDg
0oLMTShtQF0F5AlwvwHkqy+Zxxs+lwsmvs8DKrIw8DCh8njNLOxRtxrU4yF3MFRhIBFQ2XxG
3W7yXq8xjULGsIsDFwF58zzq0YBpFPDc6XIKp/iFI4S7h5BbWGoFW03gyABVtyzxT8Ab8Xze
i+tkcykAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:08'!
markGoodIcon
	^ Icons
			at: #'markGood'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markGoodIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:06'!
markGoodIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAC5SURBVDjLY/j//z8DJZhh1ADs
BjjsspIC4gb77ZZX7TdbXLVda9Zgs8xEihQDGmZfm/7/0KOD/3ff3/V/6plJ/y3mGjYQbYD9
NsurBx4e+D/10tT/nWc6/i+5sui/+RS9q0QbYLfB/OrWO1v+d5/p+t96qvn/3Auz/pt0aRNv
gPVyk4appyf+X3xl4f/ZF2b+n3Co579+mSrxXrCcZyhlMV2/wbRP56pRq+ZV3SLlBq1EOanR
lEgjAwAXIuIDq5qm/AAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:08'!
markUnknownIcon
	^ Icons
			at: #'markUnknown'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self markUnknownIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:07'!
markUnknownIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABlSURBVCjPY/jPgB8yDC4FilKK
DfJXZa6KNwhKYVfQkPW/63/b/+T/XA1YFchd7fqf/j/2f+N/5qtYFUhe7fif9D/sf91/BuwK
hBoS/jcBpcP/M2C3gluKrYHhKhA2MEgN2pDEDgEb0f5zlvXgVgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:08'!
removeMarkupIcon
	^ Icons
			at: #'removeMarkup'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self removeMarkupIconContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-codemarker' stamp: 'mt 2/5/2009 18:07'!
removeMarkupIconContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABbSURBVCjPzdAxDoAgEERRzsFp
95JbGI2ASA2SCOX3Ahtr8tuXTDIO959bCxRfpOitWS5vA+lMJg9JbKCTTmMQ1QS3ThqVQbBB
lsbgpXLYE8lHCXrqLptf9km7Dzv+FwGTaznIAAAAAElFTkSuQmCC'! !

!OBPluggableTextMorphWithShout class methodsFor: '*xpf-codemarker' stamp: 'mt 1/26/2009 14:54'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^XpfTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^XpfTextMorph! !

OBTextMorphWithShout subclass: #XpfTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker'!

!XpfTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^XpfEditor! !

!RunArray class methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:50'!
scanFrom: strm
	"Read the style section of a fileOut or sources file.  nextChunk has already been done.  We need to return a RunArray of TextAttributes of various kinds.  These are written by the implementors of writeScanOn:"
	| rr vv aa this |
	(strm peekFor: $( ) ifFalse: [^ nil].
	rr := OrderedCollection new.
	[strm skipSeparators.
	 strm peekFor: $)] whileFalse: 
		[rr add: (Number readFrom: strm)].
	vv := OrderedCollection new.	"Value array"
	aa := OrderedCollection new.	"Attributes list"
	[(this := strm next) == nil] whileFalse: [
		this == $, ifTrue: [vv add: aa asArray.  aa := OrderedCollection new].
		this == $a ifTrue: [aa add: 
			(TextAlignment new alignment: (Integer readFrom: strm))].
		this == $f ifTrue: [aa add: 
			(TextFontChange new fontNumber: (Integer readFrom: strm))].
		this == $F ifTrue: [aa add: (TextFontReference toFont: 
			(StrikeFont familyName: (strm upTo: $#) size: (Integer readFrom: strm)))].
		this == $b ifTrue: [aa add: (TextEmphasis bold)].
		this == $i ifTrue: [aa add: (TextEmphasis italic)].
		this == $u ifTrue: [aa add: (TextEmphasis underlined)].
		this == $= ifTrue: [aa add: (TextEmphasis struckOut)].
		this == $n ifTrue: [aa add: (TextEmphasis normal)].
		this == $- ifTrue: [aa add: (TextKern kern: -1)].
		this == $+ ifTrue: [aa add: (TextKern kern: 1)].
		this == $c ifTrue: [aa add: (TextColor scanFrom: strm)]. "color"
		this == $h ifTrue: [aa add: (XpfTextBackgroundColor scanFrom: strm)]. "background color - CodeMarker"
		this == $L ifTrue: [aa add: (TextLink scanFrom: strm)].	"L not look like 1"
		this == $R ifTrue: [aa add: (TextURL scanFrom: strm)].
				"R capitalized so it can follow a number"
		this == $q ifTrue: [aa add: (TextSqkPageLink scanFrom: strm)].
		this == $p ifTrue: [aa add: (TextSqkProjectLink scanFrom: strm)].
		this == $P ifTrue: [aa add: (TextPrintIt scanFrom: strm)].
		this == $d ifTrue: [aa add: (TextDoIt scanFrom: strm)].
		"space, cr do nothing"
		].
	aa size > 0 ifTrue: [vv add: aa asArray].
	^ self runs: rr asArray values: vv asArray
"
RunArray scanFrom: (ReadStream on: '(14 50 312)f1,f1b,f1LInteger +;i')
"! !

!MCStWriter methodsFor: '*xpf' stamp: 'SR 1/29/2009 18:45'!
writeMethodPreamble: definition
	stream
		cr;
		nextPut: $!!;
		nextPutAll: definition fullClassName;
		nextPutAll: ' methodsFor: ';
		nextPutAll: definition category asString printString;
		nextPutAll: ' stamp: ';
		nextPutAll: definition timeStamp asString printString;
		nextPutAll: '!!';
		cr! !

!MCStWriter methodsFor: '*xpf' stamp: 'cs 2/5/2009 17:03'!
writeMethodSource: definition
	stream nextChunkPutWithStyle: definition sourceCode.! !

!MCMethodDefinition class methodsFor: '*xpf' stamp: 'SR 1/27/2009 16:38'!
clearCachedDefinitions
	Definitions := nil.
	Instances := nil.! !

!MCMethodDefinition class methodsFor: '*xpf' stamp: 'cs 2/5/2009 16:55'!
forMethodReference: aMethodReference
	| definition |
	definition := self cachedDefinitions at: aMethodReference compiledMethod ifAbsent: [].
	(definition isNil
		or: [definition selector ~= aMethodReference methodSymbol]
		or: [definition className ~= aMethodReference classSymbol]
		or: [definition classIsMeta ~= aMethodReference classIsMeta]
		or: [definition category ~= aMethodReference category])
			ifTrue: [definition := self 
						className: aMethodReference classSymbol
						classIsMeta: aMethodReference classIsMeta
						selector: aMethodReference methodSymbol
						category: aMethodReference category
						timeStamp: aMethodReference timeStamp
						source: aMethodReference sourceCode.
					self cachedDefinitions at: aMethodReference compiledMethod put: definition].
	^ definition! !

!MCMethodDefinition methodsFor: '*xpf' stamp: 'cs 2/5/2009 16:57'!
initializeWithClassName: classString
classIsMeta: metaBoolean
selector: selectorString
category: catString
timeStamp: timeString
source: sourceString
	className := classString asSymbol.
	selector := selectorString asSymbol.
	category := catString asSymbol.
	timeStamp := timeString.
	classIsMeta := metaBoolean.
	source := sourceString.! !

!MCMethodDefinition methodsFor: '*xpf' stamp: 'cs 2/5/2009 16:59'!
source
	^ source asString withSqueakLineEndings! !

!MCMethodDefinition methodsFor: '*xpf' stamp: 'cs 2/5/2009 16:57'!
sourceCode
	^source asText! !

!MultiNewParagraph methodsFor: '*xpf-codemarker' stamp: 'mt 1/22/2009 16:27'!
displayOn: aCanvas using: displayScanner at: somePosition 
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft) 
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: 
			[ :i | 
			line := lines at: i.
			self
				drawBackgroundOn: aCanvas
					at: line;
				displaySelectionInLine: line
					on: aCanvas.
			line first <= line last ifTrue: 
				[ leftInRun := displayScanner 
					displayLine: line
					offset: offset
					leftInRun: leftInRun ] ]! !

!MultiNewParagraph methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:46'!
drawBackgroundOn: aCanvas at: line 
	| cb1 cb2 textLine bgAttr |
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: 
		[ :start :stop :attributes | 
		bgAttr := attributes 
			detect: [ :each | each isMemberOf: XpfTextBackgroundColor ]
			ifNone: [  ].
		bgAttr ifNotNil: 
			[ cb1 := self characterBlockForIndex: start + (line first - 1).
			cb2 := self characterBlockForIndex: stop + (line first - 1).
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 right @ line bottom)
				color: bgAttr color ] ]! !

!MultiNewParagraph methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:46'!
removeBackgroundForSelection
	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text removeAttributeOfKind: XpfTextBackgroundColor from: selectionStart stringIndex to: selectionStop stringIndex - 1! !

!MultiNewParagraph methodsFor: '*xpf-codemarker' stamp: 'topa 2/13/2009 13:46'!
setBackgroundForSelectionWith: aColor
	selectionStart stringIndex == selectionStop ifTrue: [^nil].
	self text addAttribute: (XpfTextBackgroundColor new color: aColor; yourself) from: selectionStart stringIndex to: selectionStop stringIndex - 1! !

OBCommand subclass: #XpfCodeMarkCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker-Commands'!

!XpfCodeMarkCommand class methodsFor: 'testing' stamp: 'cs 1/27/2009 17:30'!
takesText
	^ true! !

!XpfCodeMarkCommand methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:13'!
execute
	"'inspired' by ORCmdPrettyPrint>>execute"
	| panel morph editor |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	editor := morph textMorph editor.
	self mark: target in: editor.
	morph hasUnacceptedEdits: true! !

!XpfCodeMarkCommand methodsFor: 'accessing' stamp: 'cs 1/27/2009 17:31'!
group
	^ #general! !

!XpfCodeMarkCommand methodsFor: 'testing' stamp: 'cs 1/27/2009 17:31'!
isActive
	^ target isKindOf: OBTextSelection! !

!XpfCodeMarkCommand methodsFor: 'as yet unclassified' stamp: 'mfp 2/3/2009 16:14'!
mark: aTarget in: anEditor
	^ self subclassResponsibility! !

XpfCodeMarkCommand subclass: #XpfMarkBadCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker-Commands'!

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mt 2/5/2009 18:09'!
icon
	^#markBadIcon! !

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:12'!
keystroke
	^ $B! !

!XpfMarkBadCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

!XpfMarkBadCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:15'!
mark: aTarget in: anEditor
	anEditor markAsBad: aTarget.! !

XpfCodeMarkCommand subclass: #XpfMarkGoodCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker-Commands'!

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mt 2/5/2009 18:11'!
icon
	^#markGoodIcon.! !

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
keystroke
	^ $G! !

!XpfMarkGoodCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:20'!
label
	^ 'mark good'! !

!XpfMarkGoodCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:20'!
mark: aTarget in: anEditor
	anEditor markAsGood: aTarget.! !

XpfCodeMarkCommand subclass: #XpfMarkUnclearCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker-Commands'!

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mt 2/5/2009 18:11'!
icon
	^#markUnknownIcon.! !

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
keystroke
	^ $U! !

!XpfMarkUnclearCommand methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:24'!
label
	^ 'mark unclear'! !

!XpfMarkUnclearCommand methodsFor: 'editor-bridge' stamp: 'mfp 2/3/2009 16:25'!
mark: aTarget in: anEditor
	anEditor markAsUnclear: aTarget.! !

XpfCodeMarkCommand subclass: #XpfRemoveMarkupCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker-Commands'!

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 18:11'!
icon
	^#removeMarkupIcon.! !

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:46'!
label
	^'remove markup'! !

!XpfRemoveMarkupCommand methodsFor: 'as yet unclassified' stamp: 'mt 2/5/2009 17:44'!
mark: aTarget in: anEditor
	anEditor removeMarkup: aTarget.! !

TextAttribute subclass: #XpfTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-CodeMarker'!

!XpfTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/26/2009 09:31'!
color: aColor
	^ self new color: aColor! !

!XpfTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/26/2009 09:42'!
scanFrom: strm
	"read a color in the funny format used by Text styles on files. c125000255 or cblue;"

	| r g b |
	strm peek isDigit
		ifTrue:
			[r := (strm next: 3) asNumber.
			g := (strm next: 3) asNumber.
			b := (strm next: 3) asNumber.
			^ self color: (Color r: r g: g b: b range: 255)].
	"A name of a color"
	^ self color: (Color perform: (strm upTo: $;) asSymbol)! !

!XpfTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!
= other 
	^ (other class == self class) 
		and: [other color = color]! !

!XpfTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:24'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 11:22'!
color
	^ color! !

!XpfTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/22/2009 17:51'!
color: aColor
	color := aColor copy alpha: 0.4.! !

!XpfTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:26'!
dominates: other
	^ other class == self class! !

!XpfTextBackgroundColor methodsFor: 'comparing' stamp: 'mt 1/22/2009 11:23'!
hash
	^ color hash! !

!XpfTextBackgroundColor methodsFor: 'html' stamp: 'mt 1/22/2009 11:25'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span style="background-color: #' , color printHtmlString , '">'! !

!XpfTextBackgroundColor methodsFor: 'printing' stamp: 'mt 1/22/2009 11:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' code: '; print: color! !

!XpfTextBackgroundColor methodsFor: 'scanning' stamp: 'mt 1/22/2009 11:27'!
writeScanOn: strm
	"Two formats.  c125000255 or cblue;"

	| nn str |
	strm nextPut: $h. "h ... highlight"
	(nn := color name) ifNotNil: [
		(self class respondsTo: nn) ifTrue: [
			^ strm nextPutAll: nn; nextPut: $;]].
	(Array with: color red with: color green with: color blue) do: [:float |
		str := '000', (float * 255) asInteger printString.
		strm nextPutAll: (str copyFrom: str size-2 to: str size)]! !
XpfRootComponent initialize!
XpfEntity initialize!
